/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#ifndef __FRAME_RATE_H__
#define __FRAME_RATE_H__
#include  <windows.h>
#include  <Mmsystem.h>
#include  <vector>
using namespace std;


class fps_counter
{
	vector<float>	vFPS, vETM;
	int idx;
	DWORD	time_in;
	bool	bFull;

public:
	fps_counter()		: idx(0), vFPS(10), vETM(10), bFull(false) {};
	fps_counter(int N)	: idx(0), vFPS(N), vETM(N),  bFull(false) {};

	void	begin_frame()		{ time_in = timeGetTime(); }
	void	end_frame()		{

		DWORD dt = timeGetTime() - time_in;

		if (dt == 0) {
			vFPS[idx] = 10000.0f;
		}
		else {
			vFPS[idx] = 1000.0f / float(dt);
		}
		vETM[idx] = float(dt);

		idx++;
		if (idx >= vFPS.size()) { idx=0; bFull=true; }
	}

	float	get_fps() const {
		int N = (bFull)  ?  vFPS.size()  :  idx;
		if (N == 0)  return 0;
		
		float sum = 0.0f;
		for (int i=0; i<N; i++) {
			sum += vFPS[i];
		}

		return sum/N;
	}

	float get_elapsed_time() const {

		int N = (bFull) ? vETM.size() : idx;
		if (N == 0)  return 0;

		float sum = 0.0f;
		for (int i = 0; i<N; i++) {
			sum += vETM[i];
		}

		return sum / N;
	}
};



#endif
